# -*- coding:utf-8 -*-

import kafka
import bson

import const

def block_consume(brokers, topic, group, user, password, isPrintCkp):
    # create a kafka consumer
    consumer = kafka.KafkaConsumer(topic,
                                   auto_offset_reset='earliest',
                                   enable_auto_commit=False,
                                   group_id=group,
                                   sasl_plain_username=user,
                                   sasl_plain_password=password,
                                   sasl_mechanism='SCRAM-SHA-512',
                                   security_protocol='SASL_PLAINTEXT',
                                   bootstrap_servers=brokers)
    # get partition of topic
    partitions = consumer.partitions_for_topic(topic)
    print("start to consumer partitions: {}".format(partitions))
    for message in consumer:
        consume(consumer, message, isPrintCkp)

def consume(consumer,message,isPrintCkp):
    headers = message.headers
    isCkp = False
    for k,_ in headers:
        if k == const.CHECKPOINT:
            #提交offset
            offsets = {
            kafka.TopicPartition(message.topic, message.partition): kafka.OffsetAndMetadata(message.offset + 1,None),
            }
            isCkp = True
            consumer.commit(offsets)
            break
    if isCkp:
        if isPrintCkp:
            print(headers)
    else:
        document = bson.decode(message.value)
        print(
            headers,
            document
        )
